
#define AT91_PTRS	1
#include "../at91m40400.h"

#define TRUE	1
#define FALSE	0
#define RED_LED		(1<<1)
#define GREEN_LED	(1<<2)
#define AMBER_LED	(1<<4)

extern unsigned short prog_array[];
extern long prog_array_size();
/* Function prototypes */

void leds_on(void);
void leds_off(void);

int main (void)
{
	int n,x;
	char output;

	output = '@';
	at91_pio->PIO_OER = 0x2 | 0x4 | 0x10 | P14;
	leds_on();
	at91_uart0->US_CR = TXDIS | RXDIS | RSTTX | RSTRX;
	for(n=0;n<0xFFFF;n++)
		x++;
	at91_uart0->US_RCR =
	at91_uart0->US_TCR = 0;
	at91_uart0->US_IDR = 0xffffffff;
	at91_pio->PIO_PDR = P14 | P15;
	at91_uart0->US_MR = Stop1Bit | NoParity | EightBits | USClk_MCK;
	at91_uart0->US_BRGR = 130; /* 20MHz /16 / 9600 Baud */
	at91_uart0->US_CR = TXEN | RXEN;
	for(n=0;n<0xFFFF;n++)
		x++;
	

	while(1)
	{
		while((at91_uart0->US_CSR & TXRDY) != TXRDY);
		at91_uart0->US_THR = output;
		leds_on();
		for(n=0;n<0xFFFF;n++)
			x++;
		leds_off();
		for(n=0;n<0xFFFF;n++)
			x++;
		if ((at91_uart0->US_CSR & RXRDY) == RXRDY)
			output = at91_uart0->US_RHR;
	}
}


void leds_on(void)
{
	at91_pio->PIO_SODR = (RED_LED | GREEN_LED | AMBER_LED);
}

void leds_off(void)
{
	at91_pio->PIO_CODR = (RED_LED | GREEN_LED | AMBER_LED);
}

void __gccmain()
{
}


