
.equ	EBI_BASE,0xFFE00000
.equ	PIO_BASE,0xFFFF0000
.equ	USART0_BASE,0xfffd0000


	.global	__main
__main:	
InitRemap:
/* set up the PIO */
	ldr	r0,PtPIOAddr		/* get address of the pio reg bank */
	mov	r1,#(0x02 | 0x04 | 0x10)/* set output port direction */
	mov	r2,#(1<<1) | (1<<2) | (1<<4)	/* set the leds to be output */
	str	r1,[r0,#0x00]		/* now enable the PIO to use these pins */
	str	r1,[r0,#0x10]		/* and make the pins output */
	ldr	r1,PtPINDIS
	str	r1,[r0,#0x04]
/* now set up the uart */
	ldr	r5,PtUSARTAddr		/* get the address of the uart */
	mov	r1,#(1 << 6)		/* enable the Transmitter */
	str	r1,[r5,#0]
	ldr	r1,PtUARTMode 		/* operate in 8 bit mode no parity */
	str	r1,[r5,#0x04]
	mov	r1,#32			/* set up 38400 baud rate */
	str	r1,[r5,#0x20]		
	mov	r1,#0x40		/* char to be  output */
loop:
	str	r1,[r5,#0x1c]		/* output charater to the usart */
	str	r2,[r0,#0x30]		/* set the output to 1 */
	ldr	r4,PtDelConst		/* load the delay constant */
DelLoop1:
	subs	r4,r4,#1		/* now sub the delay counter by 1 */
	bne	DelLoop1		/* and loop back if not reached 0 */
	str	r2,[r0,#0x34]		/* now turn off the output */
	ldr	r4,PtDelConst		/* load the delay constant */
DelLoop2:
	subs	r4,r4,#1		/* dec the delay counter by 1 */
	bne	DelLoop2		/* if not yet done then loop back for more delay */
	beq	loop			/* else start the whole cycle over again */

/* 32,768 MHz master clock assumed */
PtInitRemap:
	.long	InitRemap               /* address where to jump after REMAP */
PtPIOAddr:
	.long	PIO_BASE
PtUSARTAddr:
	.long	USART0_BASE
PtDelConst:
	.long	0x8000
PtPINDIS:
	.long	(1 << 14) | (1 << 15) | (1 << 21) | (1 << 22)
PtUARTMode:
	.long	(1 << 6) | (1 << 7) | (1 << 11)            
